﻿using System;
using System.Data;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using Infragistics.Web.UI.GridControls;
using Usaid.Security;
using Usaid.FieldSupport.Business;

namespace WebApplication1
{
    public partial class WebForm1 : System.Web.UI.Page
    {

        #region Declaration
        public enum enumTab
        {
            None = 0,
            GeneralInfomation = 1,
            Transaction = 3,
            Comment = 4,
            SubObligation = 5,
        }
        #endregion

        public int VS_PlanDrctvID
        {
            get
            {
                if (ViewState["PlanDrctvID"] == null)
                    return -1;
                return (int)ViewState["PlanDrctvID"];
            }
            set
            {
                ViewState["PlanDrctvID"] = value;
            }
        }

        public int VS_CntryID
        {
            get
            {
                if (ViewState["CntryID"] == null)
                    return -1;
                return (int)ViewState["CntryID"];
            }
            set
            {
                ViewState["CntryID"] = value;
            }

        }

        protected void Page_Load(object sender, EventArgs e)
        {

            igrdSubObligation.EnsureTemplates();
            if (Page.IsPostBack == false)
            {

                int _planDrctvID;
                bool _readOnly = false;

                _planDrctvID = 87601;

                FSDataPlan fsDataPlan = new FSDataPlan(_planDrctvID);

                fsDataPlan.IsPopulated();
                InitData(_planDrctvID, fsDataPlan.FiscalYr, _readOnly, fsDataPlan.FundSrcCd, fsDataPlan.CntryID, false);

                BindData(enumTab.GeneralInfomation);
            }
        }

        protected void ibtnGeneralInfo_Click(object sender, ImageClickEventArgs e)
        {
            ChangeTabPage(enumTab.GeneralInfomation);
        }

        protected void ibtnTransaction_Click(object sender, System.Web.UI.ImageClickEventArgs e)
        {
            ChangeTabPage(enumTab.Transaction);

        }

        protected void ibtnComment_Click(object sender, System.Web.UI.ImageClickEventArgs e)
        {
            ChangeTabPage(enumTab.Comment);
        }

        protected void ibtnSubObligation_Click(object sender, System.Web.UI.ImageClickEventArgs e)
        {
            ChangeTabPage(enumTab.SubObligation);
        }

        public void InitData(int pPlanDrctvID, string pFiscalYr, bool pReadOnly, string pFundSource, int pCntryID, bool lockFundSource)
        {
            VS_PlanDrctvID = pPlanDrctvID;
            VS_CntryID = pCntryID;
        }

        public void BindData(enumTab pTab)
        {
            ChangeTabPage(pTab);
        }

        private void ChangeTabPage(enumTab pTab)
        {
            GeneralInfoPanel.Visible = false;
            SubObligationPanel.Visible = false;
            TransactionPanel.Visible = false;
            CommentPanel.Visible = false;
            igrdSubObligation.Visible = false;

            switch (pTab)
            {
                case enumTab.GeneralInfomation:
                    GeneralInfoPanel.Visible = true;
                    break;
                case enumTab.SubObligation:
                    SubObligationPanel.Visible = true;
                    BindDataSubOb();
                    igrdSubObligation.Visible = true;
                    break;
                case enumTab.Transaction:
                    TransactionPanel.Visible = true;
                    break;
                case enumTab.Comment:
                    CommentPanel.Visible = true;
                    break;
            }
        }

        public void BindDataSubOb()
        {
            SubObPlanCase subObPlanCase = new SubObPlanCase();

            DataView dvTransRows;
            DataTable dTable;
            DataColumn[] dk = new DataColumn[1];

            dvTransRows = subObPlanCase.Load_SubObPlan(VS_PlanDrctvID);

            dTable = dvTransRows.ToTable();
            dk[0] = dTable.Columns["FalseKey"];
            dTable.PrimaryKey = dk;
            dTable.TableName = "TransRow";

            igrdSubObligation.DataSource = dTable;
            igrdSubObligation.DataMember = "TransRow";
            igrdSubObligation.DataBind();

        }

        protected void grid_Init(object sender, EventArgs e)
        {
            Infragistics.Web.UI.GridControls.WebDataGrid grid;
            grid = (Infragistics.Web.UI.GridControls.WebDataGrid)sender;
            SubObCase subObCase = new SubObCase();
            grid.DataSource = subObCase.Load_SubOb(VS_CntryID, VS_PlanDrctvID);
            grid.DataBind();
        }

    }
}